#! /usr/local/bin/perl

use strict;
use warnings;

use File::Copy; 

my $file = 'file1';

open my $fh, '<', $file
  or die "Cannot open '$file': $!";

my $infos = {};

while (my $line = <$fh>){
    chomp $line;
     
    my ($ev1, $ev2, $xc, $coh, $ev1id, $ev2id, $sta, $com) = split(',', $line);

    my @snums = ($ev1,$ev2); 
    my $ev_min = smin(@snums);
    my $ev_max = smax(@snums);

    #print "# ev1 = " . $ev1 . " ev2 = " . $ev2 . "\n"; 
    #print "# minimum value = " . smin(@snums) . "\n"; 
    #print "# maximum value = " . smax(@snums) . "\n"; 

    my $evidIn = $ev_min."-".$ev_max;

    $infos->{$evidIn} ||= {};

    $infos->{$evidIn}{count}++;
    
    if($ev_min eq $ev1){
	$infos->{$evidIn}{evid_min}=$ev1id;
	$infos->{$evidIn}{evid_max}=$ev2id;

    }else{
	$infos->{$evidIn}{evid_min}=$ev2id;
	$infos->{$evidIn}{evid_max}=$ev1id;
    }

    $infos->{$evidIn}{staIn}[$infos->{$evidIn}{count}]= $sta;
    $infos->{$evidIn}{comIn}[$infos->{$evidIn}{count}]= $com;
    $infos->{$evidIn}{xcIn}[$infos->{$evidIn}{count}]= $xc;
    $infos->{$evidIn}{cohIn}[$infos->{$evidIn}{count}]= $coh;



}

my $outfile = "xc_link.out";
open(my $tmpfh2, ">", $outfile)
    or die "Cannot open $outfile: $!";



########### each evid pairs ########
for my $evidIn (sort keys %$infos) {

    my ($ev1OUT, $ev2OUT) = split('-', $evidIn);
    my $countOUT = $infos->{$evidIn}{count};

    my $evid_minOUT = $infos->{$evidIn}{evid_min};
    my $evid_maxOUT = $infos->{$evidIn}{evid_max};

    my $tmpfile = "tmp.xc.out";

    open(my $tmpfh, ">", $tmpfile)
	or die "Cannot open $tmpfile: $!";

    print $tmpfh "xc,coh,sta,com\n";
    
    my $stacomOUT = "";

    for (my $i = 1; $i <= $countOUT; $i++) {

	my $xcOUT = $infos->{$evidIn}{xcIn}[$i];	
	my $cohOUT = $infos->{$evidIn}{cohIn}[$i];	
	my $staOUT = $infos->{$evidIn}{staIn}[$i];	
	my $comOUT = $infos->{$evidIn}{comIn}[$i];	

	$stacomOUT = $stacomOUT."".$staOUT."-".$comOUT."_";

	print $tmpfh $xcOUT .",".  $cohOUT . "," . $staOUT . "," . $comOUT . "\n"
	    or die "Error Writing $tmpfile: $!";

    }

    close $tmpfh
	or die "Error closing $tmpfile";



############### do R ###############

    system("R --vanilla --slave <./xc_median.R");

    my $file2 = 'xc_median.out';
    
    open my $fh2, '<', $file2
	or die "Cannot open '$file2': $!";
    
    my $xc_median = 0;
    my $xc_mean = 0; 
    my $xc_min = 0;
    my $xc_max = 0;
    my $coh_median = 0;
    my $coh_mean = 0;
    my $coh_min = 0;
    my $coh_max = 0;
    
    while (my $line2 = <$fh2>){
	chomp $line2;	
	($xc_median, $xc_mean, $xc_min, $xc_max, $coh_median, $coh_mean, $coh_min, $coh_max) = split(',', $line2);
    }
############### do R ###############


#1984.062.103827 1984.062.144935 9670 9657 8568 8584


    print $tmpfh2 $ev1OUT ." ".  $ev2OUT . " " . $xc_mean . " " . $coh_mean . " " . $evid_minOUT . " " . $evid_maxOUT . " " . $countOUT . " " . $stacomOUT ."\n"
	or die "Error Writing $outfile: $!";
}


close $tmpfh2
    or die "Error closing $outfile";


########### each evid pairs ########

sub max{
  my @nums = @_;
  
  my $max_num;
  for my $num (@nums) {
    if (!defined $max_num) {
      $max_num = $num;
    }
    else{
      if ($num > $max_num) {
        $max_num = $num;
      }
    }
  }
  return $max_num;
}


sub smax{
  my @snums = @_;
  
  my $smax_num;
  for my $snum (@snums) {
    if (!defined $smax_num) {
      $smax_num = $snum;
    }
    else{
      if ($snum gt $smax_num) {
        $smax_num = $snum;
      }
    }
  }
  return $smax_num;
}

sub min{
  my @nums = @_;
  my $min_num;
  for my $num (@nums) {
    if (!defined $min_num){
      $min_num = $num;
    }
    else {
      if ($num < $min_num){
        $min_num = $num;
      }
    }
  }
  return $min_num;
}

sub smin{
  my @snums = @_;
  my $smin_num;
  for my $snum (@snums) {
    if (!defined $smin_num){
      $smin_num = $snum;
    }
    else {
      if ($snum lt $smin_num){
        $smin_num = $snum;
      }
    }
  }
  return $smin_num;
}
